###  get_pitch_dur_F1F2.praat     by M. Kitahara & K. Tajima (2008/1/1)
###  Measure pitch range of target word, and duration, F1, F2 of vowels.

###  Ask for file name, and read in files
form Enter file name
   word File_name CA_ac3_shinbunya
endform
Read from file... 'file_name$'.wav
Read from file... 'file_name$'.TextGrid

###  Create Pitch and Formant objects
select TextGrid 'file_name$'
n_seg = Get number of intervals... 2
n_tone = Get number of points... 3
select Sound 'file_name$'
To Pitch... 0.01 50 500
select Sound 'file_name$'
To Formant (burg)... 0 5 5500 0.025 50

###  Measure f0 min, max, and range, and output results
for i to n_tone
   select TextGrid 'file_name$'
   label$ = Get label of point... 3 i
   time = Get time of point... 3 i
   select Pitch 'file_name$'
   if left$(label$,1) = "H"
      max_f0 = Get value at time... time Hertz Linear
   elsif label$ = "L"
      min_f0 = Get value at time... time Hertz Linear
   endif
endfor
diff = max_f0 - min_f0
printline FILE'tab$''file_name$'
printline MaxPitch'tab$'MinPitch'tab$'Diff
printline 'max_f0''tab$''min_f0''tab$''diff'

###  Measure vowel duration and F1, F2 freq, and output results
printline Segment'tab$'Duration'tab$'F1'tab$'F2
for i to n_seg
   select TextGrid 'file_name$'
   label$ = Get label of interval... 2 i
   if index_regex(label$,"[aiueo]") > 0
      sstart = Get starting point... 2 i
      send = Get end point... 2 i
      smid = (send+sstart) / 2
      dur = send-sstart
      select Formant 'file_name$'
      f1 = Get value at time... 1 smid Hertz Linear
      f2 = Get value at time... 2 smid Hertz Linear
      printline 'label$''tab$''dur''tab$''f1''tab$''f2'
   endif
endfor
printline
